function [K,R] = fdm_assemble()
%
%   [K,R] = fdm_assemble(data)
%

global data

% handle data (DESEMPAQUETAMOS los datos)
Dt = data.param.dt;
rho = data.param.rho;
Cp = data.param.Cp;
conductivity = data.param.conductivity;
ntime = data.param.ntime;
xnod = data.xnod;
state = data.state;
state_old = data.state_old;
source = data.source;
fixa = data.fixa;

% calculamos las contribuciones nodales
fdm_assemble_2D;

% gather contributions (juntamos las contribuciones nodales en un sistema
% sparse global

if data.pre_step
    % aqui se ingresa cuando se comienza el calculo y no se ha armado la
    % matriz previamente, es decir se ingresa solo una vez para calcular la
    % matriz porque se supone que esta no varia
    K = sparse(rowg,colg,coeg);
    data.K = K;        % se carga en memoria la matriz una vez calculada
    data.pre_step = 0; % esta variable se pone a cero y es la que controla el IF
else
    K = data.K;  % se toma la matriz de la memoria sin calcularla
end